//update list
//2002.5.23 add memcpy
//2002.8.27 mark audio and add netdev
/*******************************define value*******************************/
//#define sunburst_kernel_lock

#define _LOOSE_KERNEL_NAMES
//fixme #undef smp_num_cpus
//fixme #undef smp_message_pass

/*******************************include header******************************/

#include <linux/config.h>
#include <linux/version.h>

#if LINUX_VERSION_CODE < 0x20600
#include <linux/modversions.h>
#endif

#include <linux/config.h>
#include <linux/ac97_codec.h>
#include <stdarg.h>

#ifdef sunburst_kernel_lock
#include <asm/spinlock.h>
#endif

#include <linux/module.h>
#include <linux/param.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/signal.h>
#include <linux/fcntl.h>
#include <linux/sched.h>
#include <linux/timer.h>
#include <linux/tty.h>
#include <linux/mm.h>
#include <linux/ctype.h>
#include <linux/delay.h>

#if LINUX_VERSION_CODE >= 132096 /* 2.4.x */
#include <asm/processor.h>
#endif

#include <linux/slab.h>
#include <linux/vmalloc.h>
#include <asm/io.h>
#include <linux/pci.h>
#include <linux/apm_bios.h>
#include <asm/segment.h>
#include <linux/tqueue.h>
#include <asm/div64.h>

#if LINUX_VERSION_CODE > 131328	/* 2.1.x */

#include <asm/uaccess.h>
#include <linux/poll.h>
#include <linux/wireless.h>
static char kernel_version[32] = UTS_RELEASE;

#else
#include <linux/bios32.h>
#endif
#include <asm/system.h>
#include <asm/dma.h>
#if LINUX_VERSION_CODE < 131097
#include <sys/kd.h>
#endif

#include <linux/wait.h>
//#include <linux/malloc.h>
#include <linux/string.h>
#include <linux/ioport.h>

#if LINUX_VERSION_CODE < 0x20600
#include <linux/interrupt.h>
#endif

#include <linux/tqueue.h>
//#include <linux/spinlock.h>

#if LINUX_VERSION_CODE>=132095
#include <linux/pm.h>
#endif

#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/skbuff.h>
#include <linux/if.h>

#if LINUX_VERSION_CODE < 0x20600
#include <pcmcia/driver_ops.h>
#endif

#include <linux/usb.h>
#include <linux/kmod.h>
#include <asm/atomic.h>

#include "./sis.h"

#include "./wrap.h"



typedef dev_node_t * (*driver_operations_attach_t) (dev_locator_t *loc);
typedef void (*driver_operations_suspend_t) (dev_node_t *dev);
typedef void (*driver_operations_resume_t) (dev_node_t *dev);
typedef void (*driver_operations_detach_t) (dev_node_t *dev);

typedef u16 (*ac97_read_t) (struct ac97_codec *,u8);
typedef void (*ac97_write_t) (struct ac97_codec *,u8,u16);
typedef int (*probe_t) (struct pci_dev *,const struct pci_device_id *);
typedef void (*remove_t) (struct pci_dev *);
typedef int (*suspend_t) (struct pci_dev *,u32);
typedef int (*resume_t) (struct pci_dev *);

typedef	int	(*netdev_open_t)(struct net_device *);
typedef	int	(*netdev_stop_t)(struct net_device *dev);
typedef int	(*netdev_hard_start_xmit_t) (struct sk_buff *skb,
						    struct net_device *dev);
typedef void (*netdev_set_multicast_list_t)(struct net_device *dev);
typedef	int	(*netdev_set_mac_address_t)(struct net_device *dev,
						   void *addr);
typedef	int	(*netdev_do_ioctl_t)(struct net_device *dev,
					    struct ifreq *ifr, int cmd);
typedef	int	(*netdev_change_mtu_t)(struct net_device *dev, int new_mtu);
typedef	struct net_device_stats* (*netdev_get_stats_t)(struct net_device *dev);
typedef	struct iw_statistics*	(*netdev_get_wireless_stats_t)(struct net_device *dev);

/*
 * These typedefs must match definition of struct file_operations.

 * (See notes in routine module_register_chrdev).
 */

#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
typedef long long (*llseek_t) (struct inode *, struct file *, long long, int);
typedef ssize_t (*read_t) (struct file *, char *, size_t, loff_t *);
typedef ssize_t (*write_t) (struct file *, const char *, size_t, loff_t *);
typedef unsigned int (*poll_t) (struct file *, poll_table *);
typedef poll_table select_table;
#else
typedef int (*lseek_t) (struct inode *, struct file *, off_t, int);
typedef int (*read_t) (struct inode *, struct file *, char *, int);
typedef int (*write_t) (struct inode *, struct file *, const char *, int);
typedef int (*select_t) (struct inode *, struct file *, int, select_table *);
#endif

typedef int (*readdir_t) (struct inode *, struct file *, void *, filldir_t);
typedef int (*ioctl_t) (struct inode *, struct file *, unsigned int,
						unsigned long);

#if LINUX_VERSION_CODE >= 131359	/* 2.1.31 */
typedef int (*mmap_t) (struct file *, struct vm_area_struct *);
#else
typedef int (*mmap_t) (struct inode *, struct file *,
					   struct vm_area_struct *);
#endif

typedef int (*open_t) (struct inode *, struct file *);

#if LINUX_VERSION_CODE >= 131359	/* 2.1.31 */
typedef int (*release_t) (struct inode *, struct file *);
typedef int (*fasync_t) (int, struct file *, int);
#else
typedef void (*release_t) (struct inode *, struct file *);
typedef int (*fasync_t) (struct inode *, struct file *, int);
#endif

typedef int (*fsync_t) (struct inode *, struct file *);

#if LINUX_VERSION_CODE<131858	/* Prior 2.3.x */
typedef int (*check_media_change_t) (kdev_t dev);
typedef int (*revalidate_t) (kdev_t dev);
#else
#define MAX_KMALLOCS 1024
//static int nr_kmallocs = 0;
//static void *kmallocs[MAX_KMALLOCS];
#endif


//////////////////////////////////////////////////////////////////////
#ifdef SIS162_USB

//static struct usb_device_id __devinitdata sis162_usb_id[] = { 

static struct usb_device_id sis162_usb_id [] = {
	{ USB_DEVICE(0x0457,0x0162) },
	{ }				
};


/* the number of entries in array above */
int const sis162_usb_id_len =
    sizeof(sis162_usb_id) / sizeof(struct usb_device_id);

/* forward for sis162_driver */
extern void usb_sis162_disconnect(struct usb_device *dev, void *ptr);
extern void *usb_sis162_probe(struct usb_device *dev, unsigned int interface,
			    const struct usb_device_id *id_table);

struct usb_driver sis162_driver = {
	name:"sis162_usb",
	probe:usb_sis162_probe,
	disconnect:usb_sis162_disconnect,
	id_table:sis162_usb_id,
};

#else //SIS162_URB else

enum {
	SIS0160 = 0,
	SIS0162 = 1,
	SIS0163 = 2,
	SIS0164 = 3,
};

static struct pci_device_id sis16x_pci_tbl[] = {
	{0x1039, 0x0160 , PCI_ANY_ID, PCI_ANY_ID, 0, 0, SIS0160},
	{0x1039, 0x0162 , PCI_ANY_ID, PCI_ANY_ID, 0, 0, SIS0162},
	{0x1039, 0x0163 , PCI_ANY_ID, PCI_ANY_ID, 0, 0, SIS0163},
	{0x1039, 0x0164 , PCI_ANY_ID, PCI_ANY_ID, 0, 0, SIS0164},
	{0,}
};

MODULE_DEVICE_TABLE (pci, sis16x_pci_tbl);

extern void __devexit sis16x_remove_one(struct pci_dev *pcidev);
extern int __devinit sis16x_init_one(struct pci_dev *pcidev,const struct pci_device_id *ent);
extern int sis16x_suspend(struct pci_dev *pcidev,u32 state);
extern int sis16x_resume(struct pci_dev *pcidev);

#define DRV_NAME "SiS016x"
static struct pci_driver sis16x_pci_driver = {
	name:		DRV_NAME,
	id_table:	sis16x_pci_tbl,
	probe:		sis16x_init_one,
	remove:		sis16x_remove_one,
#ifdef CONFIG_PM	
	suspend:	sis16x_suspend,
	resume:		sis16x_resume,
#endif	
};
#endif //SIS162_USB

///////////////////////////////////////////////////////////////////
#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
static loff_t
no_llseek (struct file *file, loff_t offset, int orig)
{
	return -EINVAL;
}

#ifndef MAP_NR
/* 2.4.0-test6 or later */
static int
no_fsync (struct file *f, struct dentry *d, int datasync)
{
	return -EINVAL;
}
#else
static int
no_fsync (struct file *f, struct dentry *d)
{
	return -EINVAL;
}
#endif

static int
no_fasync (int x, struct file *f, int m)
{
	return -EINVAL;
}
#endif


////////////////////////////////////////////////////////////////////////////
//	Function : struct file access routines.
//	Description :
//		Routines used for seting/geting member from struct file
//	Parameters :

//
//	Return :
//		get : the member in struct file
//		set : none
////////////////////////////////////////////////////////////////////////////
mode_t
file_get_mode(file_handle * file)
{
	return ((struct file *) file)->f_mode;
}
int
file_get_flags (file_handle * file)
{
	return ((struct file *) file)->f_flags;
}
loff_t *
file_get_f_pos(file_handle * file)
{
	return &((struct file *) file)->f_pos;
}
void *
file_get_private (file_handle * file)
{
	return ((struct file *) file)->private_data;
}
void
file_set_flags (file_handle * file, int flags)
{
	((struct file *) file)->f_flags |= flags;
}
void
file_set_private (file_handle * file, void *v)
{
	((struct file *) file)->private_data = v;
}

#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
dentry_handle *
file_get_dentry (file_handle * file)
{
	return (dentry_handle *) dget (((struct file *) file)->f_dentry);
}

inode_handle * dentry_get_inode (dentry_handle * d)
{
	return (inode_handle *) ((struct dentry *) d)->d_inode;
}

#endif

inode_handle *
file_get_inode (file_handle * file)
{
#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
  if (((struct file *) file)->f_dentry == NULL ||
	  ((struct file *) file)->f_dentry->d_inode == NULL)
	panic ("sndobj: file_get_inode called for bad file\n");
  return (inode_handle *) ((struct file *) file)->f_dentry->d_inode;
#else
  return (inode_handle *) ((struct file *) file)->f_inode;
#endif
}
////////////////////////////////////////////////////////////////////////////
//	Function : vm_area_struct access routines
//	Description :
//		Routines used for seting/geting member from struct vm_area_struct
//	Parameters :
//
//	Return :
//		get : the member in struct vm_area_struct
//		set : none
////////////////////////////////////////////////////////////////////////////

#if LINUX_VERSION_CODE<131858	/* Prior 2.3.x */
#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
void
vma_mmap_file (vm_area_handle * vma, file_handle * file)
{
	((struct vm_area_struct *) vma)->vm_file = (struct file *) file;
	((struct file *) file)->f_count++;
}
#else
void
vma_set_inode (vm_area_handle * vma, inode_handle * inode)
{
	((struct vm_area_struct *) vma)->vm_inode = (struct inode *) inode;
}
#endif
#endif

int
vma_get_flags (vm_area_handle * vma)
{
	return ((struct vm_area_struct *) vma)->vm_flags;
}

unsigned long
vma_get_offset (vm_area_handle * vma)
{
#if LINUX_VERSION_CODE<131858	/* Prior 2.3.x */
	return ((struct vm_area_struct *) vma)->vm_offset;
#else
	return ((struct vm_area_struct *) vma)->vm_pgoff;
#endif
}

unsigned long
vma_get_start (vm_area_handle * vma)
{
	return ((struct vm_area_struct *) vma)->vm_start;
}

unsigned long
vma_get_end (vm_area_handle * vma)
{
	return ((struct vm_area_struct *) vma)->vm_end;
}

pgprot_t vma_get_page_prot (vm_area_handle * vma)
{
	return ((struct vm_area_struct *) vma)->vm_page_prot;
}

/**********************************global variable**********************************/

static int wrapper_initialized = 1;


/**********************************function************************************/


/**********************************version check routine***********************/
int sis_connect(void)
{
//	printk ("version is %d\n",LINUX_VERSION_CODE);
	return (LINUX_VERSION_CODE);
}

/**********************************spin_lock routine***************************/

void sis_spin_unlock(void * __lock)
{
	spinlock_t **lock2 = (spinlock_t **)__lock;
	spinlock_t *lock = (spinlock_t *)(*lock2);

	spin_unlock(lock);
}
void sis_spin_lock(void *__lock)
{
	spinlock_t **lock2 = (spinlock_t **)__lock;
	spinlock_t *lock = (spinlock_t *)(*lock2);

	spin_lock(lock);
}
void sis_spin_lock_free(void *__lock)
{
	spinlock_t **lock2 = (spinlock_t **)__lock;
	
	if(*lock2)
		kfree(*lock2);
}
void sis_spin_lock_init(void *__lock)
{
	spinlock_t **lock2 = (spinlock_t **)__lock;
	spinlock_t *lock = kmalloc(sizeof(spinlock_t),GFP_ATOMIC);

//	spinlock_t *lock = (spinlock_t *)__lock;
	
	spin_lock_init(lock);
	*lock2 = lock;
}
void sis_spin_lock_irqsave(void * __lock,unsigned long *flag)
{
	spinlock_t **lock2 = (spinlock_t **)__lock;
	spinlock_t *lock = (spinlock_t *)(*lock2);
	spin_lock_irqsave(lock,*flag);
}

void sis_spin_unlock_irqrestore(void * __lock, unsigned long *flag)
{
	spinlock_t **lock2 = (spinlock_t **)__lock;
	spinlock_t *lock = (spinlock_t *)(*lock2);
	spin_unlock_irqrestore(lock,*flag);
}

#ifdef sunburst_kernel_lock
static void sis_lock_kernel(void)
{

	lock_kernel();
}

static void sis_unlock_kernel(void)
{
	unlock_kernel();
}
#endif

/******************************************irq routine************************/
void sis_synchronize_irq(void)
{
	synchronize_irq();
}

int sis_request_irq(unsigned int irq,void (*handler)(int, void *, struct pt_regs *),unsigned long shirq,const char *name,void *devid)
{
	return request_irq(irq,handler,shirq,name,devid);
}

void sis_free_irq(unsigned int irq,void *obj)
{
	free_irq(irq,obj);
}

/******************************************memory management routine**************/
void * sis_memcpy(void *to,void *from,size_t n)
{
	return memcpy(to,from,n);
}
void * sis_memset(void *x,int i,size_t t)
{
	return memset(x,i,t);
}

void * sis_get_free_pages(int order)
{
	return (void *)__get_free_pages(GFP_KERNEL | GFP_DMA, order);
}
void sis_free_pages(unsigned long addr,unsigned int order)
{
	free_pages(addr,order);
}
void sis_kfree(void *addr)
{
	kfree(addr);
}

void * sis_kmalloc(unsigned long s, int oldmask)
{
	int mask=0;

	if (oldmask&OSS_GFP_KERNEL)mask|=GFP_KERNEL;
	return kmalloc (s, mask);
}
void sis_mem_map_set(unsigned long map)
{
	set_bit(PG_reserved,&mem_map[map].flags);
}

void sis_mem_map_clear(unsigned long map)
{
	clear_bit(PG_reserved,&mem_map[map].flags);
}
void sis_mem_map_unreserve(struct page *page)
{
	clear_bit(PG_reserved,&(page->flags));
//	return (mem_map_unreserve(page));
}

void sis_mem_map_reserve(struct page *page)
{

	set_bit(PG_reserved,&(page->flags));
//	return (mem_map_reserve(page));
}
void * sis_ioremap (unsigned long offset, unsigned long size)
{
	return ioremap(offset,size);
}
void sis_iounmap(void *addr)
{
	iounmap(addr);
}
#if LINUX_VERSION_CODE >= 132096
struct page  * sis_virt_to_page(char *buf)
{
	return 	virt_to_page(buf);
}
#endif
void
sis_reserve_page(void * rawbuf,unsigned int size)
{
   	struct page *pend,*page;
   	pend = sis_virt_to_page(rawbuf+size);
	for(page=sis_virt_to_page(rawbuf);page<=pend;page++)
		sis_mem_map_reserve(page);

}
void
sis_unreserve_page(void * rawbuf,unsigned int size)
{
   	struct page *pend,*page;
   	pend = sis_virt_to_page(rawbuf+size);
	for(page=sis_virt_to_page(rawbuf);page<=pend;page++)
		sis_mem_map_unreserve(page);

}
/******************************************task routine************************/
void sis_udelay(unsigned long delay)
{
	udelay(delay);
}
void sis_mdelay(unsigned long delay)
{
	mdelay(delay);
}
#if LINUX_VERSION_CODE>=131858
void sis_interruptible_sleep_on_timeout(wait_handle *p,signed long tout)
{
	wait_queue_head_t *w = (wait_queue_head_t *) p;
	if (w == NULL)
	{
	  //printk ("tsleep wait_handle == NULL\n");
	  return;
	}
	interruptible_sleep_on_timeout (w, tout);
}
#else
void sis_interruptible_sleep_on_timeout(wait_handle **p,signed long tout)
{
	struct wait_queue **w = (struct wait_queue **) p;
	if (w == NULL)
	{
	  //printk ("tsleep wait_handle == NULL\n");
	  return;
	}
	interruptible_sleep_on_timeout (w, tout);
}
#endif
void sis_schedule_timeout(signed long timeout)
{
//  	current->state = TASK_INTERRUPTIBLE;
	schedule_timeout(timeout);
}

#if LINUX_VERSION_CODE>=131858
void sis_wake_up (wait_handle * p)
{
	wait_queue_head_t *w = (wait_queue_head_t *) p;
	if (w == NULL)
	{
	  //printk ("wake wait_handle == NULL\n");
	  return;
	}
	wake_up (w);
}
#else
void sis_wake_up (wait_handle ** p)
{
	struct wait_queue **w = (struct wait_queue **) p;
	if (w == NULL)
	{
	 // printk ("wake wait_handle == NULL\n");
	  return;
	}
	wake_up (w);
}
#endif
#if LINUX_VERSION_CODE >= 131858
void sis_add_wait_queue(wait_handle *q,wait_handle *new)
{
	wait_queue_head_t *w;
	wait_queue_t *n;

	w = (wait_queue_head_t *) q;
	n = (wait_queue_t *) new;
	add_wait_queue(w,n);
}
#else
void sis_add_wait_queue(wait_handle **q,wait_handle *new)
{
	struct wait_queue **w;
	struct wait_queue  *n;

	w = (struct wait_queue **) q;
	n = (struct wait_queue *) new;
	add_wait_queue(w,n);
}
#endif
#if LINUX_VERSION_CODE >= 131858
void sis_remove_wait_queue(wait_handle * head, wait_handle * old)
{
	wait_queue_head_t *h;
	wait_queue_t *o;
	h = (wait_queue_head_t *) head;
	o = (wait_queue_t *) old;
	remove_wait_queue(h,o);
}
#else
void sis_remove_wait_queue(wait_handle ** head, wait_handle * old)
{
	struct wait_queue **h;
	struct wait_queue *o;
	h = (struct wait_queue **) head;
	o = (struct wait_queue *) old;
	remove_wait_queue(h,o);
}
#endif

static wait_handle * sis_declare_waitqueue(void)
{
//	DECLARE_WAITQUEUE(wait,current);
	wait_queue_t *wa = (wait_queue_t *)kmalloc(sizeof(wait_queue_t),GFP_KERNEL);
	wa->flags = 0x0;
	wa->task = current;
	wa->task_list.next = NULL;
	wa->task_list.prev = NULL;
#if WAITQUEUE_DEBUG
  	wa->__magic = (long)&(current).__magic;
  	wa->__creator = 0;
#endif

	return ((wait_handle *) wa);
}
static void sis_remove_queue(wait_handle * wait)
{
	wait_queue_t * wa = (wait_queue_t *)wait;
	kfree(wa);
}

void sis_init_waitqueue_head(wait_handle * wait)
{
	wait_queue_head_t *w = (wait_queue_head_t *) wait;
	init_waitqueue_head(w);
}
#if LINUX_VERSION_CODE>=	131858
void	sis_poll_wait (file_handle * filp, wait_handle * wait_address,poll_table_handle * p)
{
	wait_queue_head_t * w = (wait_queue_head_t *) wait_address;
	poll_table *t = (poll_table *) p;

	struct file *fil = (struct file *) filp;

	poll_wait(fil,w,t);

//	return poll_wait(filp,wait_address,p);

}
#else
void	sis_poll_wait (file_handle * filp, wait_handle ** wait_address,poll_table_handle * p)
{
	struct wait_queue ** w = (struct wait_queue **) wait_address;
	poll_table *t = (poll_table *) p;
	struct file *fil = (struct file *) filp;

	poll_wait(fil,w,t);

//	return poll_wait(filp,wait_address,p);

}
#endif
/***********************************io routing**************************/
void sis_request_region(unsigned long start,unsigned long n,const char *name)
{
	request_region(start,n,name);
}

void sis_release_region(unsigned long start,unsigned long range)
{
	return release_region(start,range);
}

int sis_check_region(unsigned long from, unsigned long extent)
{
	return check_region (from, extent);
}

/***********************************user interface routing******************/
unsigned long sis_copy_from_user(void *to,const void *from, unsigned long n)
{
	return copy_from_user(to,from,n);
}
unsigned long sis_copy_to_user(void *to,const void *from, unsigned long n)
{
	return copy_to_user(to,from,n);
}

int sis_printk(const char * fmt)
{

	//printk(fmt);
	//printk("\n");
}
void sis_print_size(unsigned int size,const char *str)
{
	//printk("%s size %x\n",str,size);
}
/******************************pci routine***************************************/
#if LINUX_VERSION_CODE >= 132096
unsigned long sis_pci_resource_start(void *pci_dev,int unit)
{


	return pci_resource_start((struct pci_dev *)pci_dev,unit);
}
#endif
int sis_pci_present(void)
{
	return pci_present();
}
int sis_pcibios_present(void)
{
	return pcibios_present();
}
int sis_pcibios_find_device(unsigned short vendor,unsigned short device,unsigned short index,unsigned char *bus,unsigned char *fun)
{
        return pcibios_find_device(vendor,device,index,bus,fun);
}
int sis_pcibios_find_class(unsigned int index,unsigned short device,unsigned char *bus,unsigned char *fun)
{

        return pcibios_find_class(index,device,bus,fun);
}

int sis_pcibios_write_config_byte(unsigned char bus,unsigned char fun,unsigned char where,unsigned char val)
{
        return pcibios_write_config_byte(bus,fun,where,val);
}
int sis_pcibios_write_config_word(unsigned char bus,unsigned char fun,unsigned char where,unsigned short val)
{
        return pcibios_write_config_word(bus,fun,where,val);
}
int sis_pcibios_write_config_dword(unsigned char bus,unsigned char fun,unsigned char where,unsigned int val)
{
        return pcibios_write_config_dword(bus,fun,where,val);
}
int sis_pcibios_read_config_byte(unsigned char bus,unsigned char fun,unsigned char where,unsigned char *val)
{
        return pcibios_read_config_byte(bus,fun,where,val);
}
int sis_pcibios_read_config_word(unsigned char bus,unsigned char fun,unsigned char where,unsigned short *val)
{
        return pcibios_read_config_word(bus,fun,where,val);
}
int sis_pcibios_read_config_dword(unsigned char bus,unsigned char fun,unsigned char where,unsigned int *val)
{
        return pcibios_read_config_dword(bus,fun,where,val);
}
/*
int sis_pci_set_dma_mask(struct pci_dev *hw,dma_addr_t mask)
{
	return pci_set_dma_mask(hw,mask);
}
*/
#if LINUX_VERSION_CODE >= 132096
int sis_pci_dma_supported(void *hwdev,dma_addr_t mask)
{
	return pci_dma_supported((struct pci_dev *)hwdev,mask);
}

int sis_pci_enable_device(void *dev)
{
	return pci_enable_device((struct pci_dev *)dev);
}
// by sunburst 2002/3/19 with 70196.c, try to trans pci_dev and pci_driver
void * sis_pci_alloc_consistent(void *hwdev,size_t size,dma_addr_handle *dmahandle)
{
	struct pci_dev *hw = (struct pci_dev *) hwdev;
	return pci_alloc_consistent(hw,size,(dma_addr_t *)dmahandle);
}

void sis_pci_free_consistent(void *hwdev,size_t size,void *vaddr,dma_addr_handle *dmahandle)
{
	struct pci_dev *hw = (struct pci_dev *) hwdev;
	dma_addr_t *dh = (dma_addr_t *)dmahandle;
	pci_free_consistent(hw,size,vaddr,*dh);
}
#endif

void sis_pci_read_config_byte(unsigned short vendor, unsigned short device,int where,u8 *val)
{
	struct pci_dev *dev = NULL;
	dev = pci_find_device(vendor, device, dev);
	pci_read_config_byte(dev,where,val);
}
unsigned long sis_pciread(unsigned long vendor,unsigned long device,unsigned long offset,unsigned long mask)
{
	unsigned long check = vendor | (device<<16);
	unsigned long i;
	unsigned long result;
	unsigned long regVal;

	int found = 0;
	for(i=0x80000000;i<0x8000ff00;i+=0x100)
	{
		outl(i, 0xcf8);
		if(inl(0xcfc)==check)
		{
			found = 1;
			break;
		}
	}

	if(found)
	{
	//printk("find device %x\n",device);
	outl(i+offset, 0xcf8);
	regVal = inl(0xcfc);
	result=(unsigned long)regVal&mask;
	//printk("iobase %x\n",AudioBase);
	return(result);
	}
	return 0;
}
void sis_pci_set_master(void *pci_dev)
{
 	pci_set_master((struct pci_dev *)pci_dev);
}

int
init_wrapper (void)
{
	wrapper_initialized = 1;

#if WAITQUEUE_DEBUG
        //printk("sis7019 : WAITQUEUE_DEBUG = 1 maybe result in errors with this driver\n");
	//printk("sis7019 : Stop to active this driver\n");
	return 0;
#endif

	return 1;
}
/*************************cli,save_flags,restore_flags***********/
static void sis_cli(void)
{
  cli();
}
static void sis_save_flags(unsigned long *flags)
{
	save_flags(*flags);
}
static void sis_restore_flags(unsigned long *flags)
{
	restore_flags(*flags);
}

///////////////////////inode routine////////////////////////////////////
int inode_get_i_rdev(inode_handle *inode)
{
	return MINOR(((struct inode *)inode)->i_rdev);
}
////////////////////////mutex routine///////////////////////////////////
void sis_init_MUTEX(semaphore_handle *sem)
{
	init_MUTEX((struct semaphore *)sem);
}
void sis_up(struct semaphore * sem)
{
	up(sem);
}
void sis_down(struct semaphore *sem)
{
	down(sem);
}
///////////////////////current routine////////////////////////////////
static task_handle * sis_get_current(void)
{
	return (task_handle *) current;
}
static void sis_set_current_state(long flags)
{
	current->state = flags;
}
static int sis_got_signal(void)
{
	return signal_pending(current);
}
////////////////////////checking routine///////////////////////////
static int sis_chk_dma_addr_t(void)
{
//#ifdef CONFIG_HIGHMEM
//  	printk("sis : Using 64-bit DMA addresses\n");
// 	return 0;
//#endif
	if(sizeof(dma_addr_t)==sizeof(unsigned int))
	return 1;
	else
	return 0;
}
///////////////////////no use routine/////////////////////////////////
void dont_use_this_function(void)
{
	unsigned long flags;
	char k[32];
	wait_handle *wait;
	sis_cli();
	sis_save_flags(&flags);
	sis_restore_flags(&flags);
	wait = sis_declare_waitqueue();
	sis_remove_queue((wait_handle *)wait);
	sis_get_current();
	sis_got_signal();
	sis_set_current_state(0);
	strcpy(k,kernel_version);
	sis_chk_dma_addr_t();
}
//////////////////////////pci register driver routine////////////////////////
#ifndef SIS162_USB
int sis_pci_register_driver(void)
{
	return pci_register_driver(&sis16x_pci_driver);
}
void sis_pci_unregister_driver(void)
{
	pci_unregister_driver(&sis16x_pci_driver);
}
int sis_pci_module_init(void)
{
	return pci_module_init(&sis16x_pci_driver);
}
#endif
//////////////////////////pci set/get routine/////////////////////////////////
void sis_pci_set_drvdata(void *ph,void *data)
{
	((struct pci_dev *)ph)->driver_data = data;
}
void * sis_pci_get_drvdata(void *ph)
{
	return ((struct pci_dev *)ph)->driver_data;
}
void sis_pci_set_dma_mask(void *ph,u64 mask)
{
	((struct pci_dev *)ph)->dma_mask = mask;
}
//////////////////////////netdev routine/////////////////////////////////////

void * sis_init_etherdev(void *dev,int priv_size)
{
	return (void *) init_etherdev((struct net_device*)dev,priv_size);
}
unsigned char * sis_netdev_get_dev_addr(void *dev)
{
	return ((struct net_device *)dev)->dev_addr;
}
void sis_netdev_set_last_rx(void *dev)
{
((struct net_device *)dev)->last_rx = jiffies;
}
void sis_netdev_set_trans_start(void *dev)
{
	((struct net_device *)dev)->trans_start = jiffies;
}
void sis_netdev_set_open(void *dev,void *open)
{
	((struct net_device *)dev)->open = (netdev_open_t) open;
}

void sis_netdev_set_stop(void *dev,void *stop)
{
	((struct net_device *)dev)->stop  = (netdev_stop_t) stop;
}
void sis_netdev_set_xmit(void *dev,void *xmit)
{
	((struct net_device *)dev)->hard_start_xmit = (netdev_hard_start_xmit_t) xmit;
}

void sis_netdev_set_mlist(void *dev,void *mlist)
{
	((struct net_device *)dev)->set_multicast_list	= (netdev_set_multicast_list_t) mlist;
}
void sis_netdev_set_maddr(void *dev,void *p)
{
	((struct net_device *)dev)->set_mac_address	= (netdev_set_mac_address_t) p;
}
void sis_netdev_set_ioctl(void *dev,void *p)
{
	((struct net_device *)dev)->do_ioctl	= (netdev_do_ioctl_t) p;
}
void sis_netdev_set_mtufun(void *dev,void *p)
{
	((struct net_device *)dev)->change_mtu	= (netdev_change_mtu_t) p;
}
void sis_netdev_set_gstats(void *dev,void *p)
{
	((struct net_device *)dev)->get_stats	= (netdev_get_stats_t) p;
}
void sis_netdev_set_gwstats(void *dev,void *p)
{
	((struct net_device *)dev)->get_wireless_stats	= (netdev_get_wireless_stats_t) p;
}
void * sis_netdev_get_priv(void *dev)
{
	return ((struct net_device *)dev)->priv;
}
void sis_netdev_set_priv(void *dev,void *priv)
{
	((struct net_device *)dev)->priv = priv;
}
unsigned short sis_netdev_get_flags(void *dev)
{
	return ((struct net_device *)dev)->flags;
}
void sis_netdev_set_flags(void *dev,unsigned short flags)
{
	((struct net_device *)dev)->flags = flags;
}
unsigned sis_netdev_get_mtu(void *dev)
{
	return ((struct net_device *)dev)->mtu;
}
void sis_netdev_set_mtu(void *dev,unsigned mtu)
{
	((struct net_device *)dev)->mtu = mtu;
}
unsigned int sis_netdev_get_irq(void *dev)
{
	return ((struct net_device *)dev)->irq;
}
void sis_netdev_set_irq(void *dev,unsigned int irq)
{
	((struct net_device *)dev)->irq = irq;
}
char * sis_netdev_get_name(void *dev)
{
	return ((struct net_device *)dev)->name;
}
void sis_netdev_set_name(void *dev,char *name)
{
	int i;
	for(i=0;i<IFNAMSIZ;i++)
	{
	if(i>sizeof(name))
		break;
	((struct net_device *)dev)->name[i] = name[i];
	}
}
unsigned long sis_netdev_get_base_addr(void *dev)
{
	return ((struct net_device *)dev)->base_addr;
}
void sis_netdev_set_base_addr(void *dev,unsigned long base_addr)
{
	((struct net_device *)dev)->base_addr = base_addr;
}
unsigned char sis_netdev_get_if_port(void *dev)
{
	return ((struct net_device *)dev)->base_addr;
}
void sis_netdev_set_if_port(void *dev,unsigned char if_port)
{
	((struct net_device *)dev)->if_port = if_port;
}
void sis_netif_start_queue(void *dev)
{
	netif_start_queue((struct net_device *)dev);
}
void sis_netif_stop_queue(void *dev)
{
	netif_stop_queue(dev);
}
//////////////////////////pcidev routine////////////////////////////
/*
unsigned char sis_pcidev_get_base_address0(void *dev)
{
	return (struct pci_dev *)dev->base_address[0];
}
void sis_pcidev_set_base_address0(void *dev,unsigned char base_address0)
{
	(struct pci_dev *)dev->base_address[0] = base_address[0];
}
*/
int sis_pci_request_regions(void * pdev, char * name)
{
	return(pci_request_regions(pdev,name));
}
void sis_pci_release_regions(void * pdev)
{
	pci_release_regions(pdev);
}
unsigned short sis_pcidev_get_vendor(void *dev)
{
	return ((struct pci_dev *)dev)->vendor;
}
void sis_pcidev_set_vendor(void *dev,unsigned short vendor)
{
	((struct pci_dev *)dev)->vendor = vendor;
}
unsigned short sis_pcidev_get_device(void *dev)
{
	return ((struct pci_dev *)dev)->device;
}
void sis_pcidev_set_device(void *dev,unsigned short device)
{
	((struct pci_dev *)dev)->device = device;
}
unsigned int sis_pcidev_get_devfn(void *dev)
{
	return ((struct pci_dev *)dev)->devfn;
}
void sis_pcidev_set_devfn(void *dev,unsigned int devfn)
{
	((struct pci_dev *)dev)->devfn = devfn;
}
unsigned int sis_pcidev_get_irq(void *dev)
{
	return ((struct pci_dev *)dev)->irq;
}
void sis_pcidev_set_irq(void *dev,unsigned int irq)
{
	((struct pci_dev *)dev)->irq = irq;
}
unsigned char sis_pcidev_bus_get_number(void *dev)
{
	return ((struct pci_dev *)dev)->bus->number;
}
void sis_pcidev_bus_set_number(void *dev,unsigned char number)
{
	((struct pci_dev *)dev)->bus->number = number;
}
//////////////////////////skbuff routine////////////////////////////
void *sis_dev_alloc_skb(unsigned int length)
{
	return (void *)(dev_alloc_skb(length));
}
unsigned char *sis_skb_put(void *skb, unsigned int len)
{
	return skb_put((struct sk_buff *)skb,len);
}
unsigned char *sis_skb_push(void *skb, unsigned int len)
{
	return skb_push((struct sk_buff *)skb,len);
}
unsigned char * sis_skb_pull(void *skb, unsigned int len)
{
	return skb_pull((struct sk_buff *)skb,len);
}
void sis_skb_reserve(void *skb, unsigned int len)
{
	skb_reserve((struct sk_buff *)skb,len);
}
void sis_skb_trim(void *skb, unsigned int len)
{
	skb_trim((struct sk_buff *)skb,len);
}
void * sis_skb_get_dev(void *skb)
{
	return (void *)(((struct sk_buff *)skb)->dev);
}
void sis_skb_set_dev(void *skb,void *dev)
{
	((struct sk_buff *)skb)->dev = (struct net_device *)dev;
}
unsigned short sis_skb_get_protocol(void *skb)
{
	return ((struct sk_buff *)skb)->protocol;
}
void sis_skb_set_protocol(void *skb,unsigned short protocol)
{
	((struct sk_buff *)skb)->protocol = protocol;
}
unsigned char sis_skb_get_ip_summed(void *skb)
{
	return ((struct sk_buff *)skb)->ip_summed;
}
void sis_skb_set_ip_summed(void *skb,unsigned char ip_summed)
{
	((struct sk_buff *)skb)->ip_summed = ip_summed;
}
unsigned int sis_skb_get_len(void *skb)
{
	return ((struct sk_buff *)skb)->len;
}
void sis_skb_set_len(void *skb,unsigned int len)
{
	((struct sk_buff *)skb)->len = len;
}
unsigned char * sis_skb_get_data(void *skb)
{
	return ((struct sk_buff *)skb)->data;
}
void sis_skb_set_data(void *skb,unsigned char *data)
{
	((struct sk_buff *)skb)->data = data;
}
//////////////////////////netif routine///////////////////////////////////////
#ifdef sis_netif
void sis_netif_mark_down(struct net_device *dev)
{
	netif_mark_down(dev);
}
void sis_netif_mark_up(struct net_device *dev)
{
	netif_mark_up(dev);
}
#endif
//////////////////////////file access routine////////////////////////////////
int sis_verify_area(int type,const void *addr,unsigned long size)
{
	return verify_area(type,addr,size);
}
//////////////////////////test routine///////////////////////////////////////
#define SIS_OP(deviceID)  \
void deviceID##_help(void)	\
{				\
	//printk("test success\n");   \	
} \
SIS_OP(sis);

void sis_tq_init(void *_tq)
{
	struct tq_struct *tq = kmalloc(sizeof(struct tq_struct),GFP_ATOMIC);
	struct tq_struct **tq2 = (struct tq_struct **)_tq;
	
	*tq2 = tq;
}
void sis_tq_free(void *_tq)
{
	struct tq_struct **tq2 = (struct tq_struct **)_tq;

	if(*tq2)
		kfree(*tq2);
}
void sis_tq_set(void * _tq,void *routine,void *data)
{
	struct tq_struct **tq2 = (struct tq_struct **)_tq;
	struct tq_struct *tq = (struct tq_struct *)(*tq2);
	
	tq->sync = 0;
	tq->routine = routine;
	tq->data = data;
}
void sis_queue_task(void *_tq)
{
	struct tq_struct **tq2 = (struct tq_struct **)_tq;

	queue_task(*tq2,&tq_immediate);	
}
void sis_run_task_queue(void)
{
	run_task_queue(&tq_immediate);
}
void sis_mark_bh(void)
{
	mark_bh(IMMEDIATE_BH);
}
//////////////////////////Add by Allen/2002/11/25//////////////////////////////
void sis_do_div(unsigned long long *n, unsigned long b) 
{     
	unsigned long long *lltemp = n;
	unsigned long base = b;
	if(base==0) base=1;
	do_div(*lltemp, base);
	return;
}
unsigned short sis_eth_type_trans(void *skb,void *dev)
{
	return eth_type_trans(skb,dev);
}
int sis_netif_rx(void *skb)
{
	return netif_rx(skb);
}
void sis_netif_device_attach(void *ndev)
{
	netif_device_attach(ndev);
}
int	sis_register_netdev(void *dev)
{
	return register_netdev(dev);
}
void sis_unregister_netdev(void *dev)
{
	unregister_netdev(dev);
}
int sis_netif_running(void *dev)
{
	return netif_running(dev);
}
//sunburst//2002/12/10
long long sis_do_gettimeofday(void)
{
	struct timeval tv;
	long long result;

	do_gettimeofday(&tv);
	result = tv.tv_usec + tv.tv_sec*1000000;
	return result;
}
////////////////////////iwreq routine//////////////////////////////
char * sis_iwreq_get_name(void * wrq)
{
	return ((struct iwreq *)wrq)->u.name;
}
void sis_iwreq_set_name(void *wrq, char *name)
{
	//((struct iwreq *)wrq)->u.name = name;
	strncpy(((struct iwreq *)wrq)->u.name,name,sizeof(*name));
}

#if WIRELESS_EXT > 5
caddr_t sis_iwreq_essid_get_point(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.pointer;
}
__u16 sis_iwreq_essid_get_length(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.length;
}
__u16 sis_iwreq_essid_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.flags;
}
void sis_iwreq_essid_set_point(void * wrq,caddr_t pointer)
{
	((struct iwreq *)wrq)->u.essid.pointer = pointer;
}
void sis_iwreq_essid_set_length(void * wrq,__u16 length)
{
	((struct iwreq *)wrq)->u.essid.length = length;
}
void sis_iwreq_essid_set_flags(void * wrq,__u16 flags)
{
	((struct iwreq *)wrq)->u.essid.flags = flags;
}
#endif //wireless_Ext >=6

#if WIRELESS_EXT > 2

__u32 sis_iwreq_freq_get_m(void * wrq)
{
	return ((struct iwreq *)wrq)->u.freq.m;
}
__u16 sis_iwreq_freq_get_e(void * wrq)
{
	return ((struct iwreq *)wrq)->u.freq.e;
}
__u8 sis_iwreq_freq_get_i(void * wrq)
{
	return ((struct iwreq *)wrq)->u.freq.i;
}
void sis_iwreq_freq_set_m(void * wrq,__u32 m)
{
	((struct iwreq *)wrq)->u.freq.m = m;
}
void sis_iwreq_freq_set_e(void * wrq,__u16 e)
{
	((struct iwreq *)wrq)->u.freq.e = e;
}
void sis_iwreq_freq_set_i(void * wrq,__u8 i)
{
	((struct iwreq *)wrq)->u.freq.i = i;
}
#endif //wireless_ext >= 3

caddr_t sis_iwreq_encoding_get_pointer(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.pointer;
}
__u16 sis_iwreq_encoding_get_length(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.length;
}
__u16 sis_iwreq_encoding_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.flags;
}
void sis_iwreq_encoding_set_point(void * wrq,caddr_t pointer)
{
	((struct iwreq *)wrq)->u.essid.pointer = pointer;
}
void sis_iwreq_encoding_set_length(void * wrq,__u16 length)
{
	((struct iwreq *)wrq)->u.essid.length = length;
}
void sis_iwreq_encoding_set_flags(void * wrq,__u16 flags)
{
	((struct iwreq *)wrq)->u.essid.flags = flags;
}
caddr_t sis_iwreq_data_get_point(void * wrq)
{
	return ((struct iwreq *)wrq)->u.data.pointer;
}
__u16 sis_iwreq_data_get_length(void * wrq)
{
	return ((struct iwreq *)wrq)->u.data.length;
}
__u16 sis_iwreq_data_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.data.flags;
}
void sis_iwreq_data_set_point(void * wrq,caddr_t pointer)
{
	((struct iwreq *)wrq)->u.data.pointer = pointer;
}
void sis_iwreq_data_set_length(void * wrq,__u16 length)
{
	((struct iwreq *)wrq)->u.data.length = length;
}
void sis_iwreq_data_set_flags(void * wrq,__u16 flags)
{
	((struct iwreq *)wrq)->u.data.flags = flags;
}

#if WIRELESS_EXT > 7
__s32 sis_iwreq_bitrate_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.bitrate.value;
}
__u8 sis_iwreq_bitrate_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.bitrate.fixed;
}
#if WIRELESS_EXT > 8
__u8 sis_iwreq_bitrate_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.bitrate.disabled;
}
__u16 sis_iwreq_bitrate_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.bitrate.flags;
}
#endif
void sis_iwreq_bitrate_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.bitrate.value = value;
}
void sis_iwreq_bitrate_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.bitrate.fixed = fixed;
}
#if WIRELESS_EXT > 8
void sis_iwreq_bitrate_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.bitrate.disabled = disabled;
}
void sis_iwreq_bitrate_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.bitrate.flags = flags;
}
#endif
#endif // wireless_ext >= 8

#if WIRELESS_EXT > 9
__s32 sis_iwreq_txpower_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.txpower.value;
}
__u8 sis_iwreq_txpower_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.txpower.fixed;
}
__u8 sis_iwreq_txpower_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.txpower.disabled;
}
__u16 sis_iwreq_txpower_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.txpower.flags;
}
void sis_iwreq_txpower_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.txpower.value = value;
}
void sis_iwreq_txpower_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.txpower.fixed = fixed;
}
void sis_iwreq_txpower_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.txpower.disabled = disabled;
}
void sis_iwreq_txpower_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.txpower.flags = flags;
}
#endif

#if WIRELESS_EXT > 7
__s32 sis_iwreq_rts_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.rts.value;
}
__u8 sis_iwreq_rts_get_fixed(void * wrq)

{
	return ((struct iwreq *)wrq)->u.rts.fixed;
}
#if WIRELESS_EXT > 8
__u8 sis_iwreq_rts_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.rts.disabled;
}
__u16 sis_iwreq_rts_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.rts.flags;
}
#endif
void sis_iwreq_rts_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.rts.value = value;
}
void sis_iwreq_rts_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.rts.fixed = fixed;
}
#if WIRELESS_EXT > 8
void sis_iwreq_rts_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.rts.disabled = disabled;
}
void sis_iwreq_rts_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.rts.flags = flags;
}
#endif

__s32 sis_iwreq_frag_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.frag.value;
}
__u8 sis_iwreq_frag_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.frag.fixed;
}
#if WIRELESS_EXT > 8
__u8 sis_iwreq_frag_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.frag.disabled;
}
__u16 sis_iwreq_frag_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.frag.flags;
}
#endif
void sis_iwreq_frag_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.frag.value = value;
}
void sis_iwreq_frag_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.frag.fixed = fixed;
}
#if WIRELESS_EXT > 8
void sis_iwreq_frag_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.frag.disabled = disabled;
}
void sis_iwreq_frag_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.frag.flags = flags;
}
#endif
__s32 sis_iwreq_sens_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.sens.value;
}
__u8 sis_iwreq_sens_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.sens.fixed;
}
#if WIRELESS_EXT > 8
__u8 sis_iwreq_sens_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.sens.disabled;
}
__u16 sis_iwreq_sens_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.sens.flags;
}
#endif
void sis_iwreq_sens_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.sens.value = value;
}
void sis_iwreq_sens_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.sens.fixed = fixed;
}
#if WIRELESS_EXT > 8
void sis_iwreq_sens_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.sens.disabled = disabled;
}
void sis_iwreq_sens_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.sens.flags = flags;
}
#endif

#endif //wireless_ext >= 8

#if WIRELESS_EXT > 10
__s32 sis_iwreq_retry_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.retry.value;
}
__u8 sis_iwreq_retry_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.retry.fixed;
}
__u8 sis_iwreq_retry_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.retry.disabled;
}
__u16 sis_iwreq_retry_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.retry.flags;
}
void sis_iwreq_retry_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.retry.value = value;
}
void sis_iwreq_retry_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.retry.fixed = fixed;
}
void sis_iwreq_retry_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.retry.disabled = disabled;
}
void sis_iwreq_retry_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.retry.flags = flags;
}
#endif

__s32 sis_iwreq_power_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.power.value;
}
__u8 sis_iwreq_power_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.power.fixed;
}
__u8 sis_iwreq_power_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.power.disabled;
}
__u16 sis_iwreq_power_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.power.flags;
}
void sis_iwreq_power_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.power.value = value;
}
void sis_iwreq_power_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.power.fixed = fixed;
}
void sis_iwreq_power_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.power.disabled = disabled;
}
void sis_iwreq_power_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.power.flags = flags;
}

#if WIRELESS_EXT > 8
__u32 sis_iwreq_get_mode(void * wrq)
{
	return ((struct iwreq *)wrq)->u.mode;
}
void sis_iwreq_set_mode(void * wrq, __u32 mode)
{
	((struct iwreq *)wrq)->u.mode = mode;
}
#endif //wireless_Ext >= 9

sa_family_t sis_iwreq_ap_addr_get_sa_family(void * wrq)
{
	return ((struct iwreq *)wrq)->u.ap_addr.sa_family;
}
void sis_iwreq_ap_addr_set_sa_family(void * wrq, sa_family_t sa_family)
{
	((struct iwreq *)wrq)->u.ap_addr.sa_family = sa_family;
}
char * sis_iwreq_ap_addr_get_sa_data(void * wrq)
{
	return ((struct iwreq *)wrq)->u.ap_addr.sa_data;
}
void sis_iwreq_ap_addr_set_sa_data(void * wrq, char * sa_data)
{
	//((struct iwreq *)wrq)->u.ap_addr.sa_data = sa_data;
	memcpy(((struct iwreq *)wrq)->u.ap_addr.sa_data,sa_data,sizeof(*sa_data));
}
void sis_iwreq_ap_addr_set_sa_data_item(void * wrq, int i, unsigned char x)
{
	((struct iwreq *)wrq)->u.ap_addr.sa_data[i] = x;
}

int sis_getsizeof_iw_range(void)
{
	return sizeof(struct iw_range);
}
//////////////////////////////module routine////////////////////
void sis_set_module_owner(void *ndev)
{
	SET_MODULE_OWNER((struct net_device *)ndev);
}
///////////////////////////////network status routine///////////////////////
void sis_set_rx(void *_status, unsigned long count)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *sis_status = (struct net_device_stats *)(*status2);

	sis_status->rx_packets = count;
}
void sis_set_tx(void *_status, unsigned long count)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *sis_status = (struct net_device_stats *)(*status2);

	sis_status->tx_packets = count;
}
void sis_set_rxdrop(void *_status, unsigned long count)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *sis_status = (struct net_device_stats *)(*status2);

	sis_status->rx_dropped = count;
}
void sis_set_rxerr(void *_status, unsigned long count)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *sis_status = (struct net_device_stats *)(*status2);

	sis_status->rx_errors = count;
}
void sis_set_txerr(void *_status, unsigned long count)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *sis_status = (struct net_device_stats *)(*status2);

	sis_status->tx_errors = count;
}
void sis_set_rxcrcerr(void *_status, unsigned long count)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *sis_status = (struct net_device_stats *)(*status2);

	sis_status->rx_crc_errors = count;
}
void sis_set_rxbytes(void *_status, unsigned long count)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *sis_status = (struct net_device_stats *)(*status2);

	sis_status->rx_bytes = count;
}
void sis_set_txbytes(void *_status, unsigned long count)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *sis_status = (struct net_device_stats *)(*status2);
	
	sis_status->tx_bytes = count;
}
void *sis_get_status(
	unsigned long rxcount,
	unsigned long txcount,
	unsigned long rxdrop,
	unsigned long rxerror,
	unsigned long txerror,
	unsigned long rxcrcerror,
	unsigned long txbytes,
	unsigned long rxbytes
)
{
	static struct net_device_stats status;
	
	memset(&status,0,sizeof(struct net_device_stats));	
	status.rx_packets = rxcount;
	status.tx_packets = txcount;
	status.rx_dropped = rxdrop;
	status.rx_errors = rxerror;
	status.tx_errors = txerror;
	status.rx_crc_errors = rxcrcerror;
	status.tx_bytes = txbytes;
	status.rx_bytes = rxbytes;
	return (void *)&status;
}
void sis_init_status(void *_status)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	struct net_device_stats *status = kmalloc(sizeof(struct net_device_stats),GFP_KERNEL);

	*status2 = status;	
}
void sis_free_status(void *_status)
{
	struct net_device_stats **status2 = (struct net_device_stats **)_status;
	
	if(*status2)
		kfree(*status2);
}
//////////////////////////skb routine///////////////////////////////
void sis_dev_kfree_skb_irq(void *skb)
{
	dev_kfree_skb_irq(skb);
}
void sis_dev_kfree_skb_any(void *skb)
{
	dev_kfree_skb_irq(skb);
}
/////////////////////////////timer routine////////////////////////
void sis_timer_free(void *timerlist,int count)
{
	char **timer = (char **)timerlist;
	int i;
	
	for(i=0;i<count;i++)	
	{
		if(timer[i])
		{
			kfree(timer[i]);
		}	
	}
}
void sis_free_timer(void *_timer)
{
	struct timer_list **timer = (struct timer_list **)_timer;
	//struct timer_list *timer = (struct timer_list *)_timer;
	
	//if(*timer)
	//	kfree(*timer);
	//*timer = NULL;	
}
void sis_timer_init(void *_timer,void *timerfun,void *context)
{
	struct timer_list **timer2 = (struct timer_list **)_timer;
	struct timer_list *timer;

//	struct timer_list *timer = (struct timer_list *)_timer;
	
	static count = 0;
	
	
	timer = kmalloc(sizeof(struct timer_list),GFP_ATOMIC);
	count++;
	
	init_timer(timer);
	timer->data = (unsigned long)context;
	timer->function = timerfun;	
	*timer2 = timer;
}
void sis_add_timer(void *_timer)
{
	struct timer_list **timer2 = (struct timer_list **)_timer;
	struct timer_list *timer = (struct timer_list *)(*timer2);
	
//	struct timer_list *timer = (struct timer_list *)(_timer);
	
	//sis_printk("add timer");
	if(timer)
	add_timer(timer);
}
void sis_start_timer(void *_timer,unsigned int ms)
{
	struct timer_list **timer2 = (struct timer_list **)_timer;
	struct timer_list *timer = (struct timer_list *)(*timer2);
	
//	struct timer_list *timer = (struct timer_list *)(_timer);

	if(timer == NULL)
		return;
		
	(timer)->expires = jiffies + (ms*HZ)/1000;
	add_timer(timer);	
}
void sis_timer_exit(void *_timer)
{
	struct timer_list **timer2 = (struct timer_list **)_timer;
	struct timer_list *timer = (struct timer_list *)(*timer2);
	
//	struct timer_list *timer = (struct timer_list *)(_timer);

	//sis_printk("del timer");
	if(timer)
	del_timer_sync(timer);
}
//////////////////////////////atomic routine////////////////////////////////
int sis_compare_exchange(long *x,unsigned long mask)
{
	long y = *x;
	atomic_set_mask(mask,x);
	if(*x==y)
		return 0;
	else
		return 1;
}
long sis_atomic_add(long * addend)
{
	atomic_t *count = (atomic_t *)addend;
	atomic_add(1,count);
	return count->counter;
}
long sis_atomic_sub(long * addend)
{
	atomic_t *count = (atomic_t *)addend;
	atomic_sub(1,count);
	return count->counter;
}
void sis_atomic_set_mask(unsigned long *addr,unsigned long mask)
{
	atomic_set_mask(mask,addr);	
}
void sis_atomic_clear_mask(unsigned long *addr, unsigned long mask)
{
	atomic_clear_mask(mask,addr);
}
////////////////////////////time routine/////////////////////////////////
void sis_get_current_time(unsigned long *time)
{
	*time = jiffies;
}

///////////////////////////////////////////////////////////////////
void sis_sleep(unsigned long us)
{
	unsigned long 		timeout;
	wait_queue_head_t	wq;
	
	if((us*HZ/1000000)<1)
		timeout = 1;
	else
		timeout = us*HZ/1000000;
	
	init_waitqueue_head(&wq);		
	timeout = interruptible_sleep_on_timeout(&wq,timeout);
	
}
////////////////////////////////////////////////////////////////////
#ifdef SIS162_USB
pid_t sis_kernel_thread(void *PollingThreadFun,void *pAdapterContext,unsigned long mask)
{
	return kernel_thread(PollingThreadFun,pAdapterContext,mask);
}
void sis_set_thread(void)
{
	daemonize ();
	reparent_to_init();
#if LINUX_VERSION_CODE < 0x20414	
	spin_lock_irq(&current->sigmask_lock);
#else	
	spin_lock_irq(&current->sighand->siglock);
#endif	
	sigemptyset(&current->blocked);
#if LINUX_VERSION_CODE < 0x20414
	recalc_sigpending(current);
	spin_unlock_irq(&current->sigmask_lock);
#else	
	recalc_sigpending();
	spin_unlock_irq(&current->sighand->siglock);
#endif	
//fixme	strncpy (current->comm, pAdapterContext->netdev->name, sizeof(current->comm) - 1);
	strncpy (current->comm, "sis162 usb", sizeof(current->comm) - 1);
	current->comm[sizeof(current->comm) - 1] = '\0';
}
void sis_flush_signals(void)
{
	if (signal_pending (current)) {
#if LINUX_VERSION_CODE < 0x20414		
		spin_lock_irq(&current->sigmask_lock);
#else
		spin_lock_irq(&current->sighand->siglock);
#endif		
		flush_signals(current);
#if LINUX_VERSION_CODE < 0x20414	
		spin_unlock_irq(&current->sigmask_lock);
#else		
		spin_unlock_irq(&current->sighand->siglock);
#endif		
	}
}
int KeWaitForSingleObject( //keep this as standard wait
				void *EventPollingThread,
				unsigned long Type,
				unsigned long Mode,
				int unused,
				void  *TimeoutValue)
{
	static int next_tick = 5 * HZ;
	int  timeout = next_tick;
	wait_queue_head_t **wq = (wait_queue_head_t **)EventPollingThread;

	timeout = interruptible_sleep_on_timeout (*wq, timeout);
}
void	KeInitializeEvent(
		void *EventPollingThread,
		unsigned long mode, // auto-clearing event
		int type                 // event initially non-signalled
		)
{
	wait_queue_head_t * wq = kmalloc(sizeof(wait_queue_head_t),GFP_ATOMIC);
	wait_queue_head_t **wq2 = (wait_queue_head_t **)EventPollingThread;
	
	*wq2 = wq;
	init_waitqueue_head(wq);
}    
void PsTerminateSystemThread(void *thr_exited)
{
#if LINUX_VERSION_CODE > 0x20409
	struct completion **temp = (struct completion **)thr_exited;
	
	if(*temp)
	complete_and_exit (*temp, 0);
#else
	struct semaphore **temp = (struct semaphore **)thr_exited;
	
	if(*temp)
	up_and_exit (*temp, 0);

#endif	
}
void sis_init_completion(void *_completion)
{	
#if LINUX_VERSION_CODE > 0x20409
	struct completion *completion = kmalloc(sizeof(struct completion),GFP_ATOMIC);
	struct completion **completion2 = (struct completion **)_completion;

	*completion2 = completion;	
	init_completion(completion);
#else
	struct semaphore *completion = kmalloc(sizeof(struct semaphore),GFP_ATOMIC);
	struct semaphore **completion2 = (struct semaphore **)_completion;

	*completion2 = completion;	
	init_MUTEX_LOCKED(completion);

#endif	
}
void sis_wait_for_completion(void *thr_exited)
{
#if LINUX_VERSION_CODE > 0x20409
	struct completion **temp = (struct completion **)thr_exited;

	if(*temp)
	{
		wait_for_completion(*temp);
		kfree(*temp);
	}
#else
	struct semaphore **temp = (struct semaphore **)thr_exited;

	if(*temp)
	{
		down(*temp);
		kfree(*temp);
	}

#endif	
}
static int sis_usb_start_wait_urb(void *_purb, int timeout, int* actual_length)
{
	struct urb *urb = (struct urb *)_purb;		

#if LINUX_VERSION_CODE < 0x2040c
	DECLARE_WAITQUEUE(wait, current);
	DECLARE_WAIT_QUEUE_HEAD(wqh);
	api_wrapper_data awd;
	int status;

	awd.wakeup = &wqh;
	init_waitqueue_head(&wqh);
	current->state = TASK_INTERRUPTIBLE;
	add_wait_queue(&wqh, &wait);
	urb->context = &awd;
	status = usb_submit_urb(urb);
	if (status) {
		// something went wrong
		usb_free_urb(urb);
		current->state = TASK_RUNNING;
		remove_wait_queue(&wqh, &wait);
		return status;
	}

	if (urb->status == -EINPROGRESS) {
		while (timeout && urb->status == -EINPROGRESS)
			status = timeout = schedule_timeout(timeout);
	} else
		status = 1;

	current->state = TASK_RUNNING;
	remove_wait_queue(&wqh, &wait);

	if (!status) {
		// timeout
		printk("usb_control/bulk_msg: timeout\n");
		usb_unlink_urb(urb);  // remove urb safely
		status = -ETIMEDOUT;
	} else
		status = urb->status;

	if (actual_length)
		*actual_length = urb->actual_length;

	usb_free_urb(urb);
  	return status;
#else
	DECLARE_WAITQUEUE(wait, current);
	struct usb_api_data awd;
	int status;

	init_waitqueue_head(&awd.wqh);

	awd.done = 0;

	set_current_state(TASK_INTERRUPTIBLE);
	add_wait_queue(&awd.wqh, &wait);
	urb->context = &awd;
	status = usb_submit_urb(urb);
	if (status) {
	        // something went wrong
	        usb_free_urb(urb);
	        set_current_state(TASK_RUNNING);
	        remove_wait_queue(&awd.wqh, &wait);
	        return status;
	}

	while (timeout && !awd.done)
	timeout = schedule_timeout(timeout);

	set_current_state(TASK_RUNNING);
	remove_wait_queue(&awd.wqh, &wait);

	if (!timeout) {
	        // timeout
	        usb_unlink_urb(urb);  // remove urb safely
	        status = -ETIMEDOUT;
	}
	else {
	        status = urb->status;
	}

	if (actual_length) {
	        *actual_length = urb->actual_length;
	}
	//printk("act length %d\n",urb->actual_length);

	usb_free_urb(urb);
#endif //2.4.12
	
	return status;
}

void ctrlcomplete(void *_purb)
{
	struct urb *purb = (struct urb *)_purb;
#if LINUX_VERSION_CODE < 0x2040c	
	api_wrapper_data *awd = (api_wrapper_data *)purb->context;
#else	
	struct usb_api_data *awd = (struct usb_api_data *)purb->context;
#endif	
	unsigned long flag;
	

	switch(purb->status)
	{
		case USB_ST_NOERROR:
			
			break;
		case USB_ST_STALL:
			//printk("stall\n");
			break;
			
		case USB_ST_TIMEOUT:
			//printk("timeout\n");
			break;
	}
	//printk("ctrl complete\n");
#if LINUX_VERSION_CODE < 0x2040c
	if(waitqueue_active(awd->wakeup))
	{
		wake_up(awd->wakeup);
	}
#else
	awd->done = 1;
	wake_up(&awd->wqh);	
#endif	

}

void KeSetEvent(void *EventPollingThread, unsigned long unused1, int unused2)
{
	wait_queue_head_t **wq = (wait_queue_head_t **)EventPollingThread;	
	
	if(*wq)
		wake_up_interruptible(*wq);
}
void *sis_fill_device_request(unsigned long requesttype,unsigned long request,unsigned long Index,int size)
{
#if LINUX_VERSION_CODE < 0x20414	

	devrequest *dr = NULL; 
	dr = kmalloc(sizeof(*dr),GFP_ATOMIC);
	if(!dr)
		return NULL;
	
	dr->requesttype = requesttype;
	dr->request = request;
	dr->index = cpu_to_le16(Index);
	dr->value = cpu_to_le16(0);
	dr->length = cpu_to_le16(size);	
#else
	struct usb_ctrlrequest *dr = NULL;

	dr = kmalloc(sizeof(*dr),GFP_ATOMIC);
	if(!dr)
		return NULL;
	
	dr->bRequestType = requesttype;
	dr->bRequest = request;
	dr->wIndex = cpu_to_le16(Index);
	dr->wValue = cpu_to_le16(0);
	dr->wLength = cpu_to_le16(size);	
#endif
	return dr;
	
}

void SIS_FILL_BULK_URB(void *urb
		,void *usbdev,int pipe
		,char *buffer,int totalLength,
		void *CompleteFun,void *context)
{
	struct usb_device *usb_dev = (struct usb_device *)usbdev;
	struct urb *purb = (struct urb *)urb;
	
#if LINUX_VERSION_CODE < 0x20600	
	FILL_BULK_URB(purb
		,usb_dev,pipe
		,buffer,totalLength,
		CompleteFun,context);
#else
	usb_fill_bulk_urb(purb
		,usb_dev,pipe
		,buffer,totalLength,
		CompleteFun,context);
#endif		
}
void SIS_FILL_CONTROL_URB(void *urb,void *usbdev,int pipe,void *dr,
			char *buffer,int length,void *CompleteFun,void *context)
{

	struct usb_device *usb_dev = (struct usb_device *)usbdev;
	struct urb * purb = (struct urb *)urb;
#if LINUX_VERSION_CODE < 0x20600	
	FILL_CONTROL_URB(purb,usb_dev,pipe,dr,
		buffer,length,CompleteFun,context);
#else
	usb_fill_control_urb(purb,usb_dev,pipe,dr,
		buffer,length,CompleteFun,context);
#endif		
}
void sis_usb_unlink_urb(void *purb)
{
	usb_unlink_urb(purb);
}
unsigned int sis_usb_rcvbulkpipe(void *usbdev,unsigned char bulk_in_ep)
{
	return usb_rcvbulkpipe(usbdev,bulk_in_ep);
}
unsigned int sis_usb_sndbulkpipe(void *usbdev,unsigned char bulk_out_ep)
{
	return usb_sndbulkpipe(usbdev, bulk_out_ep);
}
unsigned int sis_usb_rcvctrlpipe(void *usbdev,unsigned char ctrl_in_ep)
{
	return usb_rcvctrlpipe(usbdev,ctrl_in_ep);
}
unsigned int sis_usb_sndctrlpipe(void *usbdev,unsigned char ctrl_out_ep)
{
	return usb_sndctrlpipe(usbdev,ctrl_out_ep);
}
int urb_get_actual_length(void *_purb)
{
	struct urb * purb = (struct urb *)_purb;
	return purb->actual_length;
	
}
void * urb_get_context(void *_purb)
{
	struct urb * purb = (struct urb *)_purb;
	return purb->context;
}
int sis_usb_set_configuration(void *_usbdev,int ifnum)
{
	struct usb_device *usbdev = (struct usb_device *)_usbdev;
	return usb_set_configuration(usbdev,usbdev->config[ifnum].bConfigurationValue);

}
int sis_usb_set_interface(void *usbdev,int ifnum,int mode)
{
	return usb_set_interface(usbdev,ifnum,mode);
}
int sis_usb_get_configuration(void *usbdev)
{
	return usb_get_configuration(usbdev);
}
int sis_usb_get_device_descriptor(void *usbdev)
{
	return usb_get_device_descriptor(usbdev);
}
int urb_get_status(void *_purb)
{
	struct urb * purb = (struct urb *)_purb;
	return purb->status;	
}
void sis_call_usermodehelper(void)
{
	char *argv[4];
	
	argv[0] = "/sbin/modprobe";
	argv[1] = "-r";
	argv[2] = (char *)sis162_driver.name;
	argv[3] = 0;
	
	call_usermodehelper(argv[0],argv,NULL);
	
}
int sis_check_product(void *dev)
{
	struct usb_device *usbdev = (struct usb_device *)dev;
	int i;
	
	for(i=0;i<sis162_usb_id_len;i++)
	{
		if(usbdev->descriptor.idVendor == sis162_usb_id[i].idVendor &&
			usbdev->descriptor.idProduct == sis162_usb_id[i].idProduct)
			break;
	}
	
	if(i==sis162_usb_id_len)
	{
		//not find device
		return 0;
	}	
	else
		return 1;
}

////////////////////////////////////////////////////////////////////
int sis_usb_register(void)
{
	return usb_register(&sis162_driver);
}
void sis_usb_deregister(void)
{
	usb_deregister(&sis162_driver);
}
void sis_usb_inc_dev_use(void *dev)
{
	usb_inc_dev_use(dev);
}
void sis_usb_dec_dev_use(void *dev)
{
	usb_dec_dev_use(dev);
}
void * sis_usb_alloc_urb(int size)
{
#if LINUX_VERSION_CODE < 0x20600	
	return usb_alloc_urb(size);
#else					//2.6.x kernel
	return usb_alloc_urb(size,GFP_ATOMIC);
#endif	
}
void sis_usb_clear_halt(void *usbdev,int pipe)
{
	usb_clear_halt(usbdev,pipe);
}
int sis_usb_submit_urb(void *urb)
{
#if LINUX_VERSION_CODE < 0x20600	
	return usb_submit_urb(urb);
#else
	return usb_submit_urb(urb,GFP_ATOMIC);
#endif	
}
void sis_usb_free_urb(void *purb)
{
	usb_free_urb(purb);
}
void sis_wait_ms(unsigned long ms)
{
	wait_ms(ms);
}
//////////////////////////////////////////////////////////////////////
void	sis_rtnl_unlock (void)
{
	rtnl_unlock();
}
void	sis_rtnl_lock (void)
{
	rtnl_lock();
}
/////////////////////////////////////////////////////////////////

MODULE_DEVICE_TABLE(usb,sis162_usb_id);
MODULE_AUTHOR("SIS DRIVER GROUP");
MODULE_DESCRIPTION("SIS 162 USB WIRELESS CARD");
#endif //SIS162_USB
